// NOISE THINGIES
gnomePlantedSoundAlarm <- {
    message = "doomsday.alarm"
    spawnflags = 33
    health = 8
}
gnomePlantedSoundAlarm <- SpawnEntityFromTable("ambient_generic", gnomePlantedSoundAlarm)

gnomeDefusedSoundAlarm <- {
    message = "Cart.Trigger"
    spawnflags = 33
    health = 10
}
gnomeDefusedSoundAlarm <- SpawnEntityFromTable("ambient_generic", gnomeDefusedSoundAlarm)

// TIMERS
gnomeResetTimer <- {
    StartDisabled = 1
    targetname = "gnomeResetTimer"
    RefireTime = 15
    "OnTimer#1": "!self,Disable,,0,-1"
    "OnTimer#2": "GBSCRIPT,RunScriptCode,RESETGNOME(),0,-1"
}
gnomeResetTimer <- SpawnEntityFromTable("logic_timer", gnomeResetTimer) // 15 Second Timer

gnomeExplodeOnOwnTimer <- {
    StartDisabled = 1
    targetname = "gnomeExplodeOnOwnTimer"
    RefireTime = 60
    "OnTimer#1": "!self,Disable,,0,-1"
    "OnTimer#2": "hogBomb,Explode,,0,-1"
    "OnTimer#3": "GBSCRIPT,RunScriptCode,RESETGNOME(),0,-1"
}
gnomeExplodeOnOwnTimer <- SpawnEntityFromTable("logic_timer", gnomeExplodeOnOwnTimer) // 60 Second Timer

gnomeExplodeWhenPlantedTimer <- {
    StartDisabled = 1
    targetname = "gnomeExplodeWhenPlantedTimer"
    RefireTime = 15
    "OnTimer#1": "!self,Disable,,0,-1"
    "OnTimer#2": "GBSCRIPT,RunScriptCode,towerBlownUp(),0,-1"
}
gnomeExplodeWhenPlantedTimer <- SpawnEntityFromTable("logic_timer", gnomeExplodeWhenPlantedTimer) // 15 Second Timer that wil cause the corresponding capped tower to be destroyed and increment the expected team score

gnomeWaitToPlayTimer <- {
    StartDisabled = 1
    targetname = "gnomeWaitToPlayTimer"
    RefireTime = 5
    "OnTimer#1": "!self,Disable,,0,-1"
    "OnTimer#2": "gnomeBomb,Enable,,0,-1"
}
gnomeWaitToPlayTimer <- SpawnEntityFromTable("logic_timer", gnomeWaitToPlayTimer)

// GAME TEXT
gnomeSpawnedText <- {
    icon = "ico_notify_flag_dropped"
    message = "GNOME SPAWNED"
    targetname = "gnomeSpawnedText"
}
gnomeSpawnedText <- SpawnEntityFromTable("game_text_tf", gnomeSpawnedText)

gnomeExplodeOnOwnText <- {
    icon = "ico_notify_sixty_seconds"
    message = "60 SECONDS UNTIL THE GNOME EXPLODES"
    targetname = "gnomeExlodedOnOwnText"
}
gnomeExplodeOnOwnText <- SpawnEntityFromTable("game_text_tf", gnomeExplodeOnOwnText)

gnomeHasExplodedText <- {
    icon = "ico_demolish"
    message = "Gnome has exploded!"
    targetname = "gnomeHasExplodedText"
}
gnomeHasExplodedText <- SpawnEntityFromTable("game_text_tf", gnomeHasExplodedText)

gnomeArmedDEFENDITText <- {
    message = "Gnome Armed - Defend it"
    targetname = "gnomeArmedDEFENDIT"
}
gnomeArmedDEFENDITText <- SpawnEntityFromTable("game_text_tf", gnomeArmedDEFENDITText)

gnomeArmedDEFUSEITText <- {
    message = "Gnome Armed - Defuse it"
    targetname = "gnomeArmedDEFUSEIT"
}
gnomeArmedDEFUSEITText <- SpawnEntityFromTable("game_text_tf", gnomeArmedDEFUSEITText)

gnomeDefusedText <- {
    message = "Gnome Defused"
    targetname = "gnomeDefused"
}
gnomeDefusedText <- SpawnEntityFromTable("game_text_tf", gnomeDefusedText)

bluTowerDestroyedText <- {
    icon = "ico_demolish"
    message = "Gnome has exploded, destroying a BLU tower!"
    targetname = "bluTowerDestroyed"
}
bluTowerDestroyedText <- SpawnEntityFromTable("game_text_tf", bluTowerDestroyedText)

redTowerDestroyedText <- {
    icon = "ico_demolish"
    message = "Gnome has exploded, destroying a RED tower!"
    targetname = "redTowerDestroyed"
}
redTowerDestroyedText <- SpawnEntityFromTable("game_text_tf", redTowerDestroyedText)

gnomeSpawnedText <- {
    icon = "ico_notify_flag_dropped"
    message = "GNOME SPAWNED"
    targetname = "gnomeSpawned"
}
gnomeSpawnedText <- SpawnEntityFromTable("game_text_tf", gnomeSpawnedText)

// GAMEPLAY FUNCTIONS
function gnomePlantedOnTower(whichone, cappedteam) //This function is called when the point is capped by the other team
{   
    if (overtimeActive == true)
    {
        EntFireByHandle(gameWin, "SetTeam", cappedteam, 0.0, null, null)
        EntFireByHandle(gameWin, "RoundWin", "", 0.0, null, null)
    }
    gnomePlanted = true
    local defusedefend = {[true]=2, [false]=3} // 2 = RED, 3 = BLU
    local makeitsoitstherightteam = true //Default to RED team for the tower
    plantedTower = whichone 
    EntFireByHandle(theGnomeBomb, "ForceDrop", "", 0.0, null, null)
    EntFireByHandle(theGnomeBomb, "Disable", "", 0.0, null, null)
    EntFireByHandle(gnomePlantedSoundAlarm, "PlaySound", "", 0.0, null, null)
    EntFireByHandle(gnomeExplodeOnOwnTimer, "Disable", "", 0.0, null, null)
    EntFireByHandle(gnomeExplodeWhenPlantedTimer, "Enable", "", 0.0, null, null)

    for(local i = 0; i < towerHolder.len(); i++)
    {
        if(plantedTower == towerHolder[i][0] || towerHolder[i][1] == 0) continue
        local towerTeam = NetProps.GetPropString(towerHolder[i][1], "team_control_point")
        if (towerTeam == 3) //Check if the tower is owned by BLU team
        {
            makeitsoitstherightteam = false
        }
    }
    NetProps.SetPropInt(gnomeArmedDEFUSEITText, "display_to_team", defusedefend[makeitsoitstherightteam])
    NetProps.SetPropInt(gnomeArmedDEFENDITText, "display_to_team", defusedefend[!makeitsoitstherightteam])
    EntFireByHandle(gnomeArmedDEFUSEITText, "Display", "", 0.0, null, null)
    EntFireByHandle(gnomeArmedDEFENDITText, "Display", "", 0.0, null, null)
    EntFireByHandle(gnomeExplodeWhenPlantedTimer, "Enable", "", 0.0, null, null)
}

function getTowerStats() // Acquire the name and the point owner for each tower
{
    local towerHolder = []
    local objResource = Entities.FindByClassname( null, "tf_objective_resource") // Thing we need to manually change the team of the contorl points
    local ControlPoint = null
    while (ControlPoint = Entities.FindByClassname(ControlPoint, "team_control_point"))   //Create a list of the current state of the towers This is their name and who owns them
    {                                                                                               
        local towerStats = []
        towerStats.append(ControlPoint.GetName()) // Get Targetname

        local pointIndexes = NetProps.GetPropInt(ControlPoint, "m_iPointIndex")
        towerStats.append(NetProps.GetPropIntArray(objResource, "m_iOwner", pointIndexes)) // Get current Owner

        towerHolder.append(towerStats)
    }
    return towerHolder
}

function towerBlownUp() // This will only be called when the 15 second countdown for the planted gnome OnTimers
{
    for(local y = 0; y < towerHolder.len(); y++) 
    {
        if(plantedTower == towerHolder[y][0]) // Run through every tower and check if the returned value of plantedTower from the ingame towers matches 
        {
            // Destroy everything belonging to the tower (Excluding the team_control_point) and increase the corresponding math_counter
            local towerCrystal = Entities.FindByName(null,"prop_" + towerHolder[y][0])
            towerCrystal.Kill() // Destroy the prop and all its children (capture zone, detection zone and defuse zone)
            local explosion = Entities.FindByName(null, "bomb_" + towerHolder[y][0])
            EntFireByHandle(explosion, "Explode", "", 0.0, null, null) // KABOOM
            local towerCP = Entities.FindByName(null, plantedTower)
            EntFireByHandle(towerCP, "SetOwner", "0", 0.0, null, towerCP) // Set owner to no one to visual show its been destroyed
            if(towerHolder[y][1] == 3) // UpdateMathCounters
            {
                EntFireByHandle(mathCounterRED, "Add", "1", 0.0, null, null)
                towersDestroyedRED += 1
            }
            else
            {
                EntFireByHandle(mathCounterBLU, "Add", "1", 0.0, null, null)
                towersDestroyedBLU += 1
            }
        }
    }
    RESETGNOME()
}

function GnomeExplodeOnCarrier() // No hogs allowed >:)
{
    local hogBomb = Entities.FindByName(null, "hogBomb")
    EntFireByHandle(hogBomb, "Explode", "", 0.0, null, null)
    theGuyCurrentlyHoldingTheGnome = null
    RESETGNOME()
}

function RESETGNOME() // This will be called in the following situations: gnome reset timer fires, gnome explode on own timer fires, a tower is destroyed
{
    //Make sure that EVERYTHING is back to what it was in the beginning
    pickBackUpCheck = false
    gnomePlanted = false
    EntFireByHandle(gnomeExplodeWhenPlantedTimer, "Disable", "", 0.0, null, null)
    EntFireByHandle(gnomeExplodeOnOwnTimer, "Disable", "", 0.0, null, null)
    EntFireByHandle(theGnomeBomb, "ForceResetAndDisableSilent", "", 0.0, null, null)
    //Teleport Gnome to one of the random positions and then enable it after 5 seconds
    local teleportEntities = []
    local startingPosition = RandomInt(0, 2)
    local teleportSpots = null
    while (teleportSpots = Entities.FindByClassname(teleportSpots, "point_teleport"))
    {
        teleportEntities.append(teleportSpots)
    }
    EntFireByHandle(teleportEntities[startingPosition], "Teleport", "", 0.0, null, null)
    EntFireByHandle(gnomeWaitToPlayTimer, "Enable", "", 0.0, null, null)
    EntFireByHandle(gnomeSpawnedText, "Display", "", 0.0, null, null)
}

function gnomePickedUp(check)
{
    EntFireByHandle(gnomeResetTimer, "Disable", "", 0.0, null, null)
    if(check)
    {
        return
    }
    pickBackUpCheck = true
    EntFireByHandle(gnomeExplodeOnOwnTimer, "Enable", "", 0.0, null, null)
}

function gnomeDropped()
{
    if(gnomePlanted == true)
    {
        return
    }
    EntFireByHandle(gnomeResetTimer, "Enable", "", 0.0, null, null)
}

function gnomeDefused()
{
    EntFireByHandle(gnomeDefusedText, "Display", "", 0.0, null, null)
    EntFireByHandle(gnomeDefusedSoundAlarm, "PlaySound", "", 0.0, null, null)
    RESETGNOME()
}

function activateOvertime()
{
    if (towersDestroyedRED > towersDestroyedBLU)
    {
        EntFireByHandle(gameWin, "SetTeam", "2", 0.0, null, null)
        EntFireByHandle(gameWin, "RoundWin", "", 0.0, null, null)
    }
    else if (towersDestroyedBLU > towersDestroyedRED)
    {
        EntFireByHandle(gameWin, "SetTeam", "3", 0.0, null, null)
        EntFireByHandle(gameWin, "RoundWin", "", 0.0, null, null)
    }
    else
    {
        overtimeActive = true
    }
}

ClearGameEventCallbacks()
function OnGameEvent_teamplay_flag_event(params) // This is called when something happens to the flag
{
    if(params.eventtype == 1) //Pickup
    {
        theGuyCurrentlyHoldingTheGnome = params.player  // Get the guy holding the gnome so we can kill them if they hold it when it blows up on its own
        gnomePickedUp(pickBackUpCheck) // check is here to make sure the 60 second countdown isn't reset
    }
    else if(params.eventtype == 4) //Dropped
    {
        theGuyCurrentlyHoldingTheGnome = null //No ones holding the gnome so erase the variable
        gnomeDropped()
    }
}

function OnPostSpawn() // Make sure the game has loaded
{
    towerHolder = getTowerStats() // Get the game state at the start of the round
}

__CollectGameEventCallbacks(this)

theGnomeBomb <- Entities.FindByClassname(null, "item_teamflag")
logicScript <- Entities.FindByName(null, "GBSCRIPT")
mathCounterBLU <- Entities.FindByName(null, "both_tPoints") // Track how many towers blu team has destroyed
towersDestroyedBLU <- 0
mathCounterRED <- Entities.FindByName(null, "red_tPoints") // Track how many towers red team has destroyed
towersDestroyedRED <- 0
gameWin <- Entities.FindByName(null, "game_win") // Because believe it not gnome bomb isn't an actually tf2 gamemode  so we have to manually set winners
theGuyCurrentlyHoldingTheGnome <- null // So we can kill the guy hogging the gnome
pickBackUpCheck <- false // To see if the 60 second timer should be enabled or disabled
gnomePlanted <- false // To see if reset timer should be enabled or disabled
towerHolder <- null // holds the names and current owners of all of the towers
overtimeActive <- false


plantedTower <- null // The tower currently planted on
